/************************************************************************************** 

	Test Description	:	This test code is to test the working of thernal diode
						    with the help of on board temperature sensor ADM1032.
						    					     

	Written by			: 	MM
	
	Date				: 	28th July, 2010

**************************************************************************************/

#include<def21469.h>
#include<Cdef21469.h>
#include<signal.h>
#include<stdio.h>
#include<sru21469.h>
#include "Thermal_Diode_ADM1032.h"

int write_pend=1;
int read_pend=1;
int buff_empty=1;

int buff[10];

int read_temp();

int current_temp=0;

int temp, temp1;

float ralh;
float rall;
float lalh;
float lalh;

float remote_alert_limit_h;
float remote_alert_limit_l;

float local_alert_limit_h;
float local_alert_limit_l;

int alert =0;
int main()
{
	


	Init_SRU();
	Init_PLL();
	Init_TWI();
	
	asm("#include<def21469.h>;");
	
	asm("bit set MODE2 IRQ0E;");
	
	asm("nop;nop;nop;nop;nop;nop;nop;nop;");
	
	*pSYSCTL|=IRQ0EN;
	
	
	interrupt(SIG_IRQ0,Alert_ISR);
	
	int i=0;

	
	write_register(CR_W,0x0A);
	temp=read_register(CR_R);
	
	
	//Set Remote Offset 
	write_register(RTOHB_W,REMOTE_OFFSET);
	temp=read_register(RTOHB_R);
	printf("\nOffset Register Set to :: %d degree C\n", temp);
	
	//Set Local and Remote THERM Limit 
	write_register(LCS_W,LOCAL_THERM_LIMIT);
	temp=read_register(LCS_W);
	printf("\nCurrent local temperature Limit set to:: %d degree C\n", temp);
	write_register(RCS_W,REMOTE_THERM_LIMIT);
	temp=read_register(RCS_R);
	printf("\nCurrent Remote Limit temperature set to :: %d degree C\n", temp);
	
	//Set THERM Hysterisis Value
	write_register(HYSTERISIS_W,THERM_HYSTERISIS);
	temp=read_register(HYSTERISIS_R);
	printf("\nCurrent THERM HYSTERISIS set to :: %d degree C\n", temp);
	
	
	//Set Remote Temperature ALERT Limits
	write_register(RHSHB_W,REMOTE_ALERT_HIGH_LIMIT);
	temp=read_register(RHSHB_R);
	printf("\nCurrent Remote /ALERT Temperature HIGH limit set to :: %d degree C\n", temp);
	write_register(RLSHB_W,REMOTE_ALERT_LOW_LIMIT);
	temp=read_register(RLSHB_R);
	printf("\nCurrent Remote /ALERT Temperature LOW limit set to :: %d degree C\n", temp);
	
	
	//Set LOCAL Temerature ALERT Limits
	write_register(LHS_W,LOCAL_ALERT_HIGH_LIMIT);
	temp=read_register(LHS_R);
	printf("\nCurrent Local /ALERT Temperature HIGH limit set to :: %d degree C\n", temp);
	write_register(LLS_W,LOCAL_ALERT_LOW_LIMIT);
	temp=read_register(LLS_R);
	printf("\nCurrent Local /ALERT Temperature LOW limit set to :: %d degree C\n", temp);
	
	//Clear any pending ALERT Latch
	Clear_Alert_Latch();
	
	int count=0;
	
	while(1)
	{
		for(i=0;i<6800000;i++);
		
		temp=read_register(LT_R);
		
		printf("\n\n\nCurrent local temperature is:: %d degree C\n", temp);
		
		temp=read_register(RTHB_R);
		
		temp1=read_register(RTLB_R);
		
		float t2=(float)(temp);
		
		temp1=temp1>>5;
		float t1=(float)(temp1);

		t1=t1*0.125;
		
		t2=t2+t1;
		
		printf("Current Remote temperature is:: %f degree C\n", t2);
		
		
		temp=read_register(SR_R);
		
	
		
		if((temp & RTHRM)!=0)
			printf("\nRemote temperature is more than its THERM limit\n");
		

		if((temp & LTHRM)!=0)
			printf("\nLocal temperature is more than its THERM limit\n");
		
		
		if((temp&(LHIGH|LLOW|RHIGH|RLOW))==0)
		{
				Clear_Alert_Latch();
				alert=0; 	
		}
		
		while(alert==1)
		{
			//Wait till the alert condition is over
			
			temp=read_register(SR_R);
				
			if((temp & LHIGH)!=0)
				printf("\nLocal temperature is more than its ALERT HIGH limit\n");
				
			if((temp & LLOW)!=0)
				printf("\nLocal temperature is less than its ALERT HIGH limit\n");
			
			if((temp & RHIGH)!=0)
				printf("\nRemote temperature is more than its ALERT HIGH limit\n");
				
			if((temp & RLOW)!=0)
				printf("\nRemote temperature is less than its ALERT HIGH limit\n");
		
			if((temp&(LHIGH|LLOW|RHIGH|RLOW))==0)
			{
				Clear_Alert_Latch();
				alert=0; 	
			}
			
		}	
			
	}

	return 0;
}

void Init_SRU()
{
	SRU(LOW,DPI_PB01_I);
	
	SRU(LOW,DPI_PB02_I);
		
	SRU(LOW,DPI_PB07_I);
	 
	SRU(TWI_DATA_PBEN_O,DPI_PBEN07_I); 

	SRU(DPI_PB07_O, TWI_DATA_I); 
	
	
	SRU(LOW,DPI_PB08_I); 
	
	SRU2(TWI_CLK_PBEN_O,DPI_PBEN08_I) ;
	
	SRU(DPI_PB08_O, TWI_CLK_I); 
}

void Init_PLL()
{
	*pPMCTL=PLLM16|INDIV;
	
	*pPMCTL|=PLLBP;
	
	int i=0;
	
	for(i=0;i<5000;i++);
	
	*pPMCTL^=PLLBP;
}
	

void Init_TWI()
{
	
	*pPICR0=TWI_INTERRUPT;
	
	interrupt(SIG_P0,ISR);
	
	*pTWIMITR=20|TWIEN;//	reference clock=159.7/16=9.984 MHz 
	
	*pTWIDIV=0x6464;
	
	*pTWIMADDR=0x4C;
	
	*pTWIFIFOCTL=TWIBHD;
	

		
}

int read_register(int add)
{
	int temp;
	
	write_pend=1;
	read_pend=1;
	
	//Write the register address in command register
	*pTXTWI8=add; 
	
	*pTWIIMASK=TWIMCOM;
		
	*pTWIMCTL=TWIDCNT1|TWIMEN;//normal mode, 7 bit addressing, no. of bytes before stop = 8
	
	while(write_pend==1);
		
	//Now read the corresponding register
	*pTWIMCTL=TWIDCNT1|TWIMEN|TWIMDIR;
		
	while(read_pend==1);
	
	temp=*pRXTWI8;
	
	return temp;
}


void write_register(int add, int data)
{
	int temp;
	
	write_pend=1;
		
	//Write the register address in command register
	*pTXTWI8=add; 
	
	*pTWIIMASK=TWIMCOM|TWITXINT;
		
	*pTWIMCTL=TWIDCNT2|TWIMEN;//normal mode, 7 bit addressing, no. of bytes before stop = 8
	
	while(buff_empty!=1);
	
	*pTXTWI8=data; 
	
	buff_empty=1;
	
	while(write_pend==1);
	
}
	
	
void ISR()
{
	
	int temp=*pTWIIRPTL;
	
	if((temp&TWIMCOM)==0)
	{
		buff_empty=1;
		temp|=TWITXINT;
		*pTWIIRPTL=temp;
	}
	else 
	{
		temp|=TWIMCOM;
		*pTWIIRPTL=temp;
	
		if(write_pend==1)
			write_pend=0;
		else
			read_pend=0;	
	}
	
	
}

void Alert_ISR()
{
	

	alert=1;
	
}



int Clear_Alert_Latch()
{
	//Clearing any Alert Latch by sending ARA  (Alert Response Address)
	
	*pTWIMADDR=0x0C;

	write_pend=0;
	read_pend=1;

	*pTWIIMASK=TWIMCOM;
	*pTWIMCTL=TWIDCNT1|TWIMEN|TWIMDIR;

	while(read_pend==1);

	temp=*pRXTWI8;

	*pTWIMADDR=0x4C;
}